using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Pong
{
    class Pad2
    {
        private Texture2D Texture;
        private Vector2 position = Vector2.Zero;
        private Vector2 speed = new Vector2(0.0f, 100.0f);
        KeyboardState OldState;

        //Contructor
        //**********
        public Pad2(Texture2D Texture)
        {
            this.Texture = Texture;
        }

        public Vector2 Position
        {
            get { return position; }
            set { position = value; }
        }

        public Vector2 Speed
        {
            get { return speed; }
            set { speed = value; }
        }

        public void Update(GraphicsDeviceManager g)
        {
            KeyboardState NewState = Keyboard.GetState();

            position += speed;
            int PMinY = 55;
            int PMaxY = g.GraphicsDevice.Viewport.Height - Texture.Height;

            if (NewState.IsKeyUp(Keys.Up) && NewState.IsKeyUp(Keys.Down))
            {
                speed.Y = 0;
            }

            if (NewState.IsKeyDown(Keys.Up))
                speed.Y = -10;
            else if (OldState.IsKeyDown(Keys.Up))
                speed.Y = 0;

            if (NewState.IsKeyDown(Keys.Down))
                speed.Y = 10;
            else if (OldState.IsKeyDown(Keys.Down))
                speed.Y = 0;

            if (position.Y > PMaxY)
            {
                speed.Y = 0;
                position.Y = PMaxY;
            }
            if (position.Y < PMinY)
            {
                speed.Y = 0;
                position.Y = PMinY;
            }

            NewState = OldState;
        }

        public void Draw(SpriteBatch SP)
        {
            SP.Draw(Texture, position, Color.White);
        }

        //Returns a rectangle around the object
        //*************************************
        public Rectangle Rect
        {
            get
            {
                return new Rectangle(
                    (int)position.X, (int)position.Y,
                    Texture.Width, Texture.Height);
            }
        }
        //Returns a rectangle around the top of the object
        //************************************************
        public Rectangle RectTop
        {
            get
            {
                return new Rectangle(
                    (int)position.X, (int)position.Y,
                    Texture.Width, (int)(Texture.Height * 0.1f));
            }
        }
        //Returns a rectangle around the Bottom of the object
        //************************************************
        public Rectangle RectBottom
        {
            get
            {
                return new Rectangle(
                    (int)position.X, ((int)position.Y + (int)(Texture.Height * 0.9f)),
                    Texture.Width, (int)(Texture.Height * 0.1f));
            }
        }

        public Rectangle BigRect
        {
            get
            {
                return new Rectangle(
                    (int)position.X, (int)position.Y,
                    Texture.Width, Texture.Height);
            }
        }

        public void Restart(Rectangle windowBounds)
        {
            position = new Vector2(windowBounds.Width - 25 - Texture.Width,
                windowBounds.Height / 2 - Texture.Height * 1.5f);
        }
    }
}